<template>
  <div class="mb-1">
    <label v-if="label" class="block text-gray-700 text-sm font-bold mb-2">
      {{ label }}
    </label>
    <input
      class="shadow appearance-none border rounded w-full py-2 px-3 mb-1 text-gray-700 leading-tight focus:outline-none focus:shadow-outline"
      :class="{ 'border-red-500': inputError }"
      v-model="model"
      v-bind="$attrs"
      @blur="handleBlur"
      @focus="handleFocus"
    />
    <div class="app-input__details">
      <transition name="fade">
        <p
          v-show="errorMessage || errorMessageLocal"
          class="text-red-500 text-xs italic"
        >
          {{ errorMessage || errorMessageLocal }}
        </p>
      </transition>
    </div>
  </div>
</template>

<script>
export default {
  name: 'appTextField',
  props: {
    value: { type: [String, Number], default: '' },
    label: { type: [String], default: '' },
    rules: { type: [Array], default: () => [] },
    errorMessage: { type: String, default: null },
    error: { type: Boolean, default: false },
  },
  data: () => ({
    errorMessageLocal: '',
    dirty: false,
  }),
  computed: {
    inputError() {
      return this.error || this.errorMessage || this.errorMessageLocal;
    },
    model: {
      get() {
        return this.value;
      },
      set(val) {
        if (this.inputError && this.dirty) {
          this.validate();
        }
        return this.$emit('input', val);
      },
    },
  },
  methods: {
    handleBlur() {
      this.validate();
    },
    validate() {
      this.dirty = true;
      this.$nextTick(() => {
        const length = (this.rules || []).length;
        for (let i = 0; i < length; i++) {
          const validateRule = this.rules[i](this.model);
          if (typeof validateRule === 'string') {
            this.errorMessageLocal = validateRule;
            return;
          }
        }
        this.errorMessageLocal = '';
      });
    },
    handleFocus() {
      this.errorMessageLocal = '';
    },
  },
};
</script>

<style>
.app-input__details {
  min-height: 16px;
}
</style>
